#Python script to transform the CPAchecker CSV files into the format i need for further evaluation (OpenOffice Tables)

import csv,re

dictSimulatorsBDD={}
dictSimulatorsCore={}
dictProducts={}

for (filename, plname) in \
[('results/MSTKruskal_11.zip.csv',"MSTKruskal_11"),\
('results/MSTKruskal_12.zip.csv',"MSTKruskal_12"),\
('results/MSTKruskal_13.zip.csv',"MSTKruskal_13"),\
('results/MSTPrim_4.zip.csv',"MSTPrim_4"),\
('results/MSTPrim_5.zip.csv',"MSTPrim_5"),\
('results/MSTPrim_6.zip.csv',"MSTPrim_6"),\
('results/MSTPrim_7.zip.csv',"MSTPrim_7"),\
('results/MSTPrim_9.zip.csv',"MSTPrim_9"),\
('results/MSTPrim_10.zip.csv',"MSTPrim_10"),\
('results/original.zip.csv',"original")\
] :


	with open(filename, 'r') as f:
	    reader = csv.reader(f, delimiter='\t')
	    reader.next()#skip first row
	    headerrow=reader.next()
	    assert headerrow[0]=="spec"
	    assert headerrow[1]=="scalingFactor"
	    assert headerrow[2]=="product"
	    assert headerrow[3]=="defect"
	    assert headerrow[4]=="time"
	    assert headerrow[5]=="states"
	    assert headerrow[6]=="compileTime"
	    assert headerrow[7]=="features"

	    

	    try:
		for row in reader:
			spec=row[0]
			product=row[2]
			if (row[3]=="false"):
				status="SAFE"
			else:
				status="DEFECT"
			cputime=row[4]
			states=row[5]
			compileTime=row[6]
			features=row[7]
		
			if (product=="psBDD"):
				key = '{0}_{1:04d}'.format(plname, int(spec))
				dictSimulatorsBDD.update({key : [plname, spec, product, states, cputime, compileTime, status]})
			elif (product=="psCore"):
				key = '{0}_{1:04d}'.format(plname, int(spec))
				dictSimulatorsCore.update({key : [plname, spec, product, states, cputime, compileTime, status]})
			else:
				key = '{0}_{1:04d}_{2:04d}'.format(plname, int(spec), int(product))
				dictProducts.update({key : [plname, spec, product, features, states, cputime, compileTime, status]})

	    except csv.Error, e:
		sys.exit('file %s, line %d: %s' % (filename, reader.line_num, e))        
if (len(dictSimulatorsBDD)>0):
	writer = csv.writer(open('SimulatorsBDD.csv', 'w'), delimiter='\t')
	for key in sorted(dictSimulatorsBDD.iterkeys()):
	    value = dictSimulatorsBDD[key]
	    print "%s: %s" % (key, value)
	    writer.writerow([value[0],value[1],value[2],"NA", "NA", value[3], value[4], value[5], "NA", 1, value[6]])
if (len(dictSimulatorsCore)>0):
	writer = csv.writer(open('SimulatorsCore.csv', 'w'), delimiter='\t')
	for key in sorted(dictSimulatorsCore.iterkeys()):
	    value = dictSimulatorsCore[key]
	    print "%s: %s" % (key, value)
	    writer.writerow([value[0],value[1],value[2],"NA", "NA", value[3], value[4], value[5], "NA", 1, value[6]])

if (len(dictProducts)>0):
	writer = csv.writer(open('Products.csv', 'w'), delimiter='\t')
	for key in sorted(dictProducts.iterkeys()):
	    value = dictProducts[key]
	    print "%s: %s" % (key, value)
	    productshort = "%s:%s" % (value[2],value[3])
	    writer.writerow([value[0],value[1],productshort,"NA", "NA", value[4], value[5], value[6], "NA", 0, value[7]])

print "format is: plname\tspec\tproduct\tNA\tNA\tstates\tcputime\tcompileTime\tNA\tisSimulator\tstatus"


